/*
   Implementation of The Dining-Philosophers Problem using pthread 
   This program doesn't occur deadlock 
*/

#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

void  philosopher( int * );
void eat( int, int );
void think( int, int );

#define NUM_THREADS 5
pthread_mutex_t mutex;
sem_t chopstick[NUM_THREADS];    /* È¤ */

int main( int argc, char *argv[] ) 
{
  int i;
  int philosopher_id[NUM_THREADS];
  pthread_t thread[NUM_THREADS];      /* array of threads */

  srand((unsigned) time(NULL)); 

  /* Initialization of the mutex here */
  pthread_mutex_init( &mutex, NULL );

  /* Initialization of the semaphore here */
  for ( i = 0; i < NUM_THREADS; i++ )
    sem_init( &chopstick[i], 0, 1 );
				      
  /* Creation of the simple threads here */
  for ( i = 0; i < NUM_THREADS; i++ ) {
    philosopher_id[i] = i;
    pthread_create( &thread[i], NULL, (void *)philosopher, &philosopher_id[i] );
  }

  /* Wait until all simple threads exit */
  for ( i = 0; i < NUM_THREADS; i++)
    pthread_join( thread[i], NULL );

  printf( "\nmain() reporting that all %d philosopers have left their table\n",
	  NUM_THREADS );

  return 0;
}  /* main */

  

void philosopher( int *id )
{
  int i;
  printf( "Philosopher %d sit down in her seat\n", *id );

  for ( i = 0; i < 5; i++ ) {
    pthread_mutex_lock( &mutex );
    sem_wait( &chopstick[(*id)] );       
    /* printf("Philosopher %d took chopstic %d\n", (*id), (*id) ); */
    if ( (rand() % 2) == 1 )
      sleep( 1 );
    sem_wait( &chopstick[((*id)+1)%NUM_THREADS] ); 
    /* printf("Philosopher %d took chopstic %d\n", (*id), ((*id)+1)%5 ); */
    pthread_mutex_unlock( &mutex ); 
    eat( (*id), (i+1) );  
    sem_post( &chopstick[(*id)] ); 
    sem_post( &chopstick[((*id)+1)%NUM_THREADS] );
    think( (*id), (i+1) );
  }
  /* Using the semaphore operation here */   
  printf( "Philosopher %d left her seat\n", *id );

}

void eat( int id, int count ) {
  printf( "Philosopher %d is eating now (%d)\n", id, count );
  do {
    sleep( 1 );
  } while ( (rand() % 2) == 1 );
}

void think( int id, int count ) {
  printf( "Philosopher %d is thinking now (%d)\n", id, count );
  do {
    sleep( 1 );
  } while ( (rand() % 2) == 1 );
}

