
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <semaphore.h>

#define NUMPHIL 5

/****************************************************************************
Variables
****************************************************************************/

sem_t sticks[NUMPHIL];
sem_t allow;
typedef struct
{
    int id, lstick, rstick;
} philo_t;

philo_t philo_args[NUMPHIL];

/****************************************************************************
Functions prototype
****************************************************************************/
void *philo(void*);

/****************************************************************************
Functions
****************************************************************************/
void *philo(void *philo_arg)
{
    philo_t *argp = (philo_t *)philo_arg;
    int id = argp->id;
    int left = argp->lstick;
    int right = argp->rstick;

    printf("\nThread-ID %ld\tID %d\tLeft %d\tRight %d\n",
           pthread_self(), id, left, right);

    while(1)
    {
        sem_wait(&allow);
        sem_wait(&sticks[left]);
        sem_wait(&sticks[right]);
        printf("Philosoph %d eating with stick %d and stick %d\n",
               id, left, right);
        fflush(stdin);
        sleep(rand() % 5); /* essen */
        printf("Philosoph %d finished eating with stick %d and stick %d\n",
               id, left, right);
        fflush(stdin);
        sem_post(&sticks[left]);
        sem_post(&sticks[right]);
	sem_post(&allow);
        sleep(rand() % 5); /* denken */
    }
    return 0; /* wird nicht erreicht  */
}

/****************************************************************************
Main
****************************************************************************/
int main()
{
    int i;
    pthread_t dummy;

    sem_init(&allow, 0, NUMPHIL-1);
    for (i = 0; i < NUMPHIL; i++)
    {
        sem_init(&sticks[i], 0, 1);
        philo_args[i].id = i;
        philo_args[i].lstick = i;
        philo_args[i].rstick = (i + 1) % NUMPHIL;
    }

    for (i = 0; i < NUMPHIL; i++)
    {
        pthread_create(&dummy, 0, philo, &philo_args[i]);
    }

    pthread_exit(NULL);
	return 0;
}
